head	1.1;
access;
symbols
	pkgsrc-2026Q1:1.1.0.72
	pkgsrc-2026Q1-base:1.1
	pkgsrc-2025Q4:1.1.0.70
	pkgsrc-2025Q4-base:1.1
	pkgsrc-2025Q3:1.1.0.68
	pkgsrc-2025Q3-base:1.1
	pkgsrc-2025Q2:1.1.0.66
	pkgsrc-2025Q2-base:1.1
	pkgsrc-2025Q1:1.1.0.64
	pkgsrc-2025Q1-base:1.1
	pkgsrc-2024Q4:1.1.0.62
	pkgsrc-2024Q4-base:1.1
	pkgsrc-2024Q3:1.1.0.60
	pkgsrc-2024Q3-base:1.1
	pkgsrc-2024Q2:1.1.0.58
	pkgsrc-2024Q2-base:1.1
	pkgsrc-2024Q1:1.1.0.56
	pkgsrc-2024Q1-base:1.1
	pkgsrc-2023Q4:1.1.0.54
	pkgsrc-2023Q4-base:1.1
	pkgsrc-2023Q3:1.1.0.52
	pkgsrc-2023Q3-base:1.1
	pkgsrc-2023Q2:1.1.0.50
	pkgsrc-2023Q2-base:1.1
	pkgsrc-2023Q1:1.1.0.48
	pkgsrc-2023Q1-base:1.1
	pkgsrc-2022Q4:1.1.0.46
	pkgsrc-2022Q4-base:1.1
	pkgsrc-2022Q3:1.1.0.44
	pkgsrc-2022Q3-base:1.1
	pkgsrc-2022Q2:1.1.0.42
	pkgsrc-2022Q2-base:1.1
	pkgsrc-2022Q1:1.1.0.40
	pkgsrc-2022Q1-base:1.1
	pkgsrc-2021Q4:1.1.0.38
	pkgsrc-2021Q4-base:1.1
	pkgsrc-2021Q3:1.1.0.36
	pkgsrc-2021Q3-base:1.1
	pkgsrc-2021Q2:1.1.0.34
	pkgsrc-2021Q2-base:1.1
	pkgsrc-2021Q1:1.1.0.32
	pkgsrc-2021Q1-base:1.1
	pkgsrc-2020Q4:1.1.0.30
	pkgsrc-2020Q4-base:1.1
	pkgsrc-2020Q3:1.1.0.28
	pkgsrc-2020Q3-base:1.1
	pkgsrc-2020Q2:1.1.0.24
	pkgsrc-2020Q2-base:1.1
	pkgsrc-2020Q1:1.1.0.4
	pkgsrc-2020Q1-base:1.1
	pkgsrc-2019Q4:1.1.0.26
	pkgsrc-2019Q4-base:1.1
	pkgsrc-2019Q3:1.1.0.22
	pkgsrc-2019Q3-base:1.1
	pkgsrc-2019Q2:1.1.0.20
	pkgsrc-2019Q2-base:1.1
	pkgsrc-2019Q1:1.1.0.18
	pkgsrc-2019Q1-base:1.1
	pkgsrc-2018Q4:1.1.0.16
	pkgsrc-2018Q4-base:1.1
	pkgsrc-2018Q3:1.1.0.14
	pkgsrc-2018Q3-base:1.1
	pkgsrc-2018Q2:1.1.0.12
	pkgsrc-2018Q2-base:1.1
	pkgsrc-2018Q1:1.1.0.10
	pkgsrc-2018Q1-base:1.1
	pkgsrc-2017Q4:1.1.0.8
	pkgsrc-2017Q4-base:1.1
	pkgsrc-2017Q3:1.1.0.6
	pkgsrc-2017Q3-base:1.1
	pkgsrc-2017Q2:1.1.0.2
	pkgsrc-2017Q2-base:1.1;
locks; strict;
comment	@# @;


1.1
date	2017.06.01.01.58.34;	author jlam;	state Exp;
branches;
next	;
commitid	ZKq8jUL9nZlDZBTz;


desc
@@


1.1
log
@Import pkgtasks-1-1.9 as pkgsrc/pkgtools/pkgtasks.

pkgtasks is a shell script library to ease writing POSIX-compliant
shell scripts to handle common tasks during installation or removal
of a package, e.g.,

  * creating groups and users needed by the package

  * creating and removing directories with special permissions and
    ownership,

  * copying example config files to their final locations during
    package installation, and removing them during package removal
    if they don't differ from the example ones,

  * reminding the user of files that may be customized after
    package installation.
@
text
@# Copyright (c) 2017 The NetBSD Foundation, Inc.
# All rights reserved.
#
# This code is derived from software contributed to The NetBSD Foundation
# by Johnny C. Lam.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
# NAME
#	maketemp.subr -- make unique, temporary files
#
# SYNOPSIS
#	task_maketemp [-dq] [-p tmpdir] [-t prefix] [template ...]
#
# DESCRIPTION
#	The task_maketemp function creates temporary files or directories using
#	unique names, and prints the names.
#
# OPTIONS
#	The available options are as follows:
#
#	-d	Make a directory instead of a file.
#
#	-p tmpdir
#		Specifies the directory in which temporary files are created.
#		If the "-p tmpdir" option is not specified, then the
#		directory defaults to ${TMPDIR}, or to /tmp if ${TMPDIR} is
#		empty.
#
#	-q	Fail silently if an error occurs.
#
#	-t prefix
#		Generate a template using an appropriate directory name,
#		followed by the supplied prefix, followed by ".XXXXXXXX".
#		Any "X" characters in the supplied prefix are taken
#		literally, but the trailing "X" characters in the appended
#		".XXXXXXXX" are replaced by unique values.
#
# EXIT STATUS
#	Returns 0 on success, and >0 if an error occurs.
#
# ENVIRONMENT
#	The following variables are used if they are set:
#
#	AWK	The name or path to the awk(1) utility.
#
#	CHMOD	The name or path to the chmod(1) utility.
#
#	MKTEMP	The name or path to the mktemp(1) utility.  task_maketemp
#		attempts to use this utility first to create the requested
#		temporary files.
#
#	TMPDIR	The default location in which temporary files are created.
#

__task_maketemp__="yes"
__task_maketemp_init__="_task_maketemp_init"

task_load cleanup
task_load createfile
task_load makedir
task_load random

task_maketemp()
{
	: ${AWK:=awk}
	: ${CHMOD:=chmod}
	: ${MKTEMP:=mktemp}

	# Default location in which temporary files and directories are
	# are created.
	#
	local tmpdir="/tmp"
	[ -z "${TMPDIR}" ] || tmpdir=${TMPDIR}

	local output
	output=$( { export TMPDIR=$tmpdir && ${MKTEMP} "$@@"; } 2>/dev/null )
	if [ $? -eq 0 ]; then
		echo "$output"
		return 0
	fi

	local result=0

	local filetype="file"
	local prefix="temp"
	local quiet=
	local arg
	local OPTIND=1
	while getopts ":dp:qt:" arg "$@@"; do
		case $arg in
		d)	filetype="dir" ;;
		p)	tmpdir=${OPTARG} ;;
		q)	quiet="yes" ;;
		t)	prefix=${OPTARG} ;;
		*)	return 127 ;;
		esac
	done
	shift $(( ${OPTIND} - 1 ))

	case $filetype in
	dir|file)
		: "valid temporary file type" ;;
	*)	return 1 ;;
	esac

	# Explicitly set the creation umask to 077, only allowing r/w/x for
	# the owner.
	#
	__task_maketemp_save_umask__=$( umask ) || return 1
	umask 077

	[ $# -gt 0 ] || set -- "$tmpdir/$prefix.XXXXXXXX"
	task_random
	local template; for template; do echo "$template"; done |
	${AWK} -v SEED=$RANDOM '
		BEGIN {
			chars =       "abcdefghijklmnopqrstuvwxyz"
			chars = chars "ABCDEFGHIJKLMNOPQRSTUVWXZZY"
			chars = chars "0123456789"
			n = split( chars, array, "" )
			srand(SEED)
		}
		{
			if ( match( $0, "X+$" ) > 0 ) {
				s = substr( $0, 1, RSTART - 1 )
				for ( i = 0; i < RLENGTH; i++ )
					s = s array[ int( n * rand() ) + 1 ]
				print s
			} else
				print
		}' |
	( while IFS= read name; do
		case $filetype in
		dir)	if task_makedir -m 0700 "$name" 2>/dev/null &&
			   [ ! -h "$name" -a -d "$name" -a \
				-r "$name" -a -w "$name" -a -x "$name" -a \
				-O "$name" ]; then
				 : "success"
			elif [ -z "$quiet" ]; then
				return 1
			else
				echo 1>&2 "task_maketemp: error creating directory \`\`$name''"
				return 1
			fi ;;
		file)	if [ ! -e "$name" ] &&
			   task_createfile -m 0600 "$name" 2>/dev/null &&
			   [ ! -h "$name" -a -f "$name" -a \
				-r "$name" -a -w "$name" -a \
				-O "$name" ]; then
				: "success"
			elif [ -z "$quiet" ]; then
				return 1
			else
				echo 1>&2 "task_maketemp: error creating file \`\`$name''"
				return 1
			fi ;;
		esac
		echo "$name"
	  done
	  return 0 )
	result=$?

	_task_maketemp_cleanup
	return $result
}

_task_maketemp_cleanup()
{
	if [ -n "$__task_maketemp_save_umask__" ]; then
		umask $__task_maketemp_save_umask__
		__task_maketemp_save_umask__=
	fi
}

_task_maketemp_init()
{
	task_cleanup_add_hook _task_maketemp_cleanup
}

# Static variable for the current umask before executing task_maketemp.
__task_maketemp_save_umask__=
@
